diff --git a/tensorflow/compiler/tests/cholesky_op_test.py b/tensorflow/compiler/tests/cholesky_op_test.py
index 0a739df1163..41a72fda402 100644
--- a/tensorflow/compiler/tests/cholesky_op_test.py
+++ b/tensorflow/compiler/tests/cholesky_op_test.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.compiler.tests import xla_test
 from tensorflow.python.framework import constant_op
@@ -79,7 +78,7 @@ class CholeskyOpTest(xla_test.XLATestCase):
 
       # Generate random positive-definite matrices.
       matrices = np.random.rand(10, 5, 5).astype(dtype)
-      for i in xrange(10):
+      for i in range(10):
         matrices[i] = np.dot(matrices[i].T, matrices[i])
       self._verifyCholesky(matrices, atol=1e-4)
 
diff --git a/tensorflow/compiler/tests/clustering_test.py b/tensorflow/compiler/tests/clustering_test.py
index 64d587268c1..ab7ed89d1e2 100644
--- a/tensorflow/compiler/tests/clustering_test.py
+++ b/tensorflow/compiler/tests/clustering_test.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.compiler.tests import xla_test
 from tensorflow.python.framework import constant_op
@@ -56,7 +55,7 @@ class ClusteringTest(xla_test.XLATestCase):
         input2 = constant_op.constant(val2, name="const2")
       with self.test_scope():
         output = math_ops.add(input1, input2)
-      for _ in xrange(10):
+      for _ in range(10):
         result = self.evaluate(output)
         self.assertAllClose(result, expected, rtol=1e-3)
 
diff --git a/tensorflow/compiler/tests/conv3d_test.py b/tensorflow/compiler/tests/conv3d_test.py
index 155b513e0d6..f0086c88614 100644
--- a/tensorflow/compiler/tests/conv3d_test.py
+++ b/tensorflow/compiler/tests/conv3d_test.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.compiler.tests import xla_test
 from tensorflow.python.framework import constant_op
@@ -100,11 +99,11 @@ class Conv3DTransposeTest(xla_test.XLATestCase):
       #   kernel_depth * ceil(kernel_height/2) * kernel_width or
       #   kernel_depth * kernel_height * ceil(kernel_width/2)
 
-      for n in xrange(x_shape[0]):
-        for k in xrange(f_shape[3]):
-          for w in xrange(y_shape[3]):
-            for h in xrange(y_shape[2]):
-              for d in xrange(y_shape[1]):
+      for n in range(x_shape[0]):
+        for k in range(f_shape[3]):
+          for w in range(y_shape[3]):
+            for h in range(y_shape[2]):
+              for d in range(y_shape[1]):
                 d_in = d > 0 and d < y_shape[1] - 1
                 h_in = h > 0 and h < y_shape[2] - 1
                 w_in = w > 0 and w < y_shape[3] - 1
@@ -137,11 +136,11 @@ class Conv3DTransposeTest(xla_test.XLATestCase):
           x, f, y_shape, strides=strides, padding="SAME")
       value = self.evaluate(output)
 
-      for n in xrange(x_shape[0]):
-        for k in xrange(f_shape[3]):
-          for w in xrange(y_shape[3]):
-            for h in xrange(y_shape[2]):
-              for d in xrange(y_shape[1]):
+      for n in range(x_shape[0]):
+        for k in range(f_shape[3]):
+          for w in range(y_shape[3]):
+            for h in range(y_shape[2]):
+              for d in range(y_shape[1]):
                 # We add a case for locations divisible by the stride.
                 d_in = d % strides[1] == 0 and 0 < d < y_shape[1] - 1
                 h_in = h % strides[2] == 0 and 0 < h < y_shape[2] - 1
@@ -180,11 +179,11 @@ class Conv3DTransposeTest(xla_test.XLATestCase):
       # The amount of padding added
       pad = 1
 
-      for n in xrange(x_shape[0]):
-        for k in xrange(f_shape[3]):
-          for w in xrange(y_shape[3]):
-            for h in xrange(y_shape[2]):
-              for d in xrange(y_shape[1]):
+      for n in range(x_shape[0]):
+        for k in range(f_shape[3]):
+          for w in range(y_shape[3]):
+            for h in range(y_shape[2]):
+              for d in range(y_shape[1]):
                 # We add a case for locations divisible by the stride.
                 d_in = d % strides[1] == 0 and pad < d < y_shape[1] - 1 - pad
                 h_in = h % strides[2] == 0 and pad < h < y_shape[2] - 1 - pad
diff --git a/tensorflow/compiler/tests/depthwise_conv_op_test.py b/tensorflow/compiler/tests/depthwise_conv_op_test.py
index a49985f0446..61dcc919512 100644
--- a/tensorflow/compiler/tests/depthwise_conv_op_test.py
+++ b/tensorflow/compiler/tests/depthwise_conv_op_test.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.compiler.tests import xla_test
 from tensorflow.python.framework import constant_op
@@ -39,7 +38,7 @@ def ReferenceDepthwiseConv2D(input_tensor, filter_tensor, strides, padding,
   convs = []
   in_channels = filter_tensor.shape[2]
   # Use a custom implementation of depthwise conv2d using slicing.
-  for channel in xrange(in_channels):
+  for channel in range(in_channels):
     # Slice the input along channel
     if data_format == "NCHW":
       input_slice = input_tensor[:, channel:channel+1, :, :]
diff --git a/tensorflow/compiler/tests/fifo_queue_test.py b/tensorflow/compiler/tests/fifo_queue_test.py
index ba80fa0a0b2..f2ff9db6d51 100644
--- a/tensorflow/compiler/tests/fifo_queue_test.py
+++ b/tensorflow/compiler/tests/fifo_queue_test.py
@@ -20,7 +20,6 @@ from __future__ import print_function
 
 import time
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.compiler.tests import xla_test
 from tensorflow.python.framework import dtypes as dtypes_lib
@@ -90,7 +89,7 @@ class FIFOQueueTest(xla_test.XLATestCase):
 
       # Dequeue every element using a single thread.
       results = []
-      for _ in xrange(len(elems)):
+      for _ in range(len(elems)):
         results.append(dequeued_t.eval())
       self.assertItemsEqual(elems, results)
 
@@ -128,7 +127,7 @@ class FIFOQueueTest(xla_test.XLATestCase):
       for enqueue_op in enqueue_ops:
         enqueue_op.run()
 
-      for i in xrange(len(elems)):
+      for i in range(len(elems)):
         vals = self.evaluate(dequeued_t)
         self.assertEqual([elems[i]], vals)
 
@@ -149,7 +148,7 @@ class FIFOQueueTest(xla_test.XLATestCase):
       results = []
 
       def dequeue():
-        for _ in xrange(len(elems)):
+        for _ in range(len(elems)):
           results.append(sess.run(dequeued_t))
 
       enqueue_thread = self.checkedThread(target=enqueue)
@@ -172,7 +171,7 @@ class FIFOQueueTest(xla_test.XLATestCase):
       for enqueue_op in enqueue_ops:
         enqueue_op.run()
 
-      for i in xrange(len(elems)):
+      for i in range(len(elems)):
         x_val, y_val = sess.run(dequeued_t)
         x, y = elems[i]
         self.assertEqual([x], x_val)
diff --git a/tensorflow/compiler/tests/image_ops_test.py b/tensorflow/compiler/tests/image_ops_test.py
index 5889a011296..2225cc021dd 100644
--- a/tensorflow/compiler/tests/image_ops_test.py
+++ b/tensorflow/compiler/tests/image_ops_test.py
@@ -24,7 +24,6 @@ import math
 from absl.testing import parameterized
 import numpy as np
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.compiler.tests import xla_test
 from tensorflow.python.framework import dtypes
@@ -230,7 +229,7 @@ class AdjustHueTest(xla_test.XLATestCase):
     x_v = x_np.reshape([-1, 3])
     y_v = np.ndarray(x_v.shape, dtype=x_v.dtype)
     channel_count = x_v.shape[0]
-    for i in xrange(channel_count):
+    for i in range(channel_count):
       r = x_v[i][0]
       g = x_v[i][1]
       b = x_v[i][2]
@@ -350,7 +349,7 @@ class AdjustSaturationTest(xla_test.XLATestCase):
     x_v = x_np.reshape([-1, 3])
     y_v = np.ndarray(x_v.shape, dtype=x_v.dtype)
     channel_count = x_v.shape[0]
-    for i in xrange(channel_count):
+    for i in range(channel_count):
       r = x_v[i][0]
       g = x_v[i][1]
       b = x_v[i][2]
diff --git a/tensorflow/compiler/tests/listdiff_op_test.py b/tensorflow/compiler/tests/listdiff_op_test.py
index b061ac3c817..a6f512b9588 100644
--- a/tensorflow/compiler/tests/listdiff_op_test.py
+++ b/tensorflow/compiler/tests/listdiff_op_test.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.compiler.tests import xla_test
 from tensorflow.python.framework import dtypes
@@ -65,7 +64,7 @@ class ListDiffTest(xla_test.XLATestCase):
     int_low = -7
     int_high = 8
     max_size = 50
-    for _ in xrange(num_random_tests):
+    for _ in range(num_random_tests):
       x_size = np.random.randint(max_size + 1)
       x = np.random.randint(int_low, int_high, size=x_size)
       y_size = np.random.randint(max_size + 1)
diff --git a/tensorflow/compiler/tests/test_utils.py b/tensorflow/compiler/tests/test_utils.py
index 0e77dbf1a79..799a677502e 100644
--- a/tensorflow/compiler/tests/test_utils.py
+++ b/tensorflow/compiler/tests/test_utils.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 
 def ConvertBetweenDataFormats(x, data_format_src, data_format_dst):
@@ -69,7 +68,7 @@ _JIT_WARMUP_ITERATIONS = 10
 
 def RunWithWarmup(sess, op_to_run, feed_dict, options=None, run_metadata=None):
   """Runs a graph a few times to ensure that its clusters are compiled."""
-  for _ in xrange(0, _JIT_WARMUP_ITERATIONS):
+  for _ in range(0, _JIT_WARMUP_ITERATIONS):
     sess.run(op_to_run, feed_dict, options=options)
   return sess.run(
       op_to_run, feed_dict, options=options, run_metadata=run_metadata)
diff --git a/tensorflow/compiler/tests/unary_ops_test.py b/tensorflow/compiler/tests/unary_ops_test.py
index 349dabbb393..ea3f70e35a5 100644
--- a/tensorflow/compiler/tests/unary_ops_test.py
+++ b/tensorflow/compiler/tests/unary_ops_test.py
@@ -21,7 +21,6 @@ from __future__ import print_function
 import unittest
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.compiler.tests import xla_test
 from tensorflow.python.framework import dtypes
@@ -81,7 +80,7 @@ class UnaryOpsTest(xla_test.XLATestCase):
   def ListsAreClose(self, result, expected, rtol, atol):
     """Tests closeness of two lists of floats."""
     self.assertEqual(len(result), len(expected))
-    for i in xrange(len(result)):
+    for i in range(len(result)):
       self.assertAllClose(result[i], expected[i], rtol, atol)
 
   def testAllTypeOps(self):
diff --git a/tensorflow/compiler/xla/cpu_function_runtime.cc b/tensorflow/compiler/xla/cpu_function_runtime.cc
index 517b30a8251..43ca4806711 100644
--- a/tensorflow/compiler/xla/cpu_function_runtime.cc
+++ b/tensorflow/compiler/xla/cpu_function_runtime.cc
@@ -16,6 +16,7 @@ limitations under the License.
 #include "tensorflow/compiler/xla/cpu_function_runtime.h"
 
 #include "tensorflow/core/platform/dynamic_annotations.h"
+#include <cstdint>
 
 namespace xla {
 namespace {
diff --git a/tensorflow/compiler/xla/python_api/xla_shape.py b/tensorflow/compiler/xla/python_api/xla_shape.py
index bdcd4abd6cc..5b59c0086eb 100644
--- a/tensorflow/compiler/xla/python_api/xla_shape.py
+++ b/tensorflow/compiler/xla/python_api/xla_shape.py
@@ -20,7 +20,6 @@ from __future__ import print_function
 
 import numpy as _np  # Avoids becoming a part of public Tensorflow API.
 
-from six.moves import xrange
 
 from tensorflow.compiler.xla import xla_data_pb2
 from tensorflow.compiler.xla.python_api import types
@@ -121,7 +120,7 @@ def _CreateShapeFromNumpy(ndarray):  # pylint: disable=invalid-name
   else:
     # Row-major layout. This corresponds to a "dimension order is
     # major-to-minor" layout int XLA.
-    layout = list(reversed(xrange(ndarray.ndim)))
+    layout = list(reversed(range(ndarray.ndim)))
 
   return Shape(element_type, dimensions, layout)
 
diff --git a/tensorflow/contrib/constrained_optimization/python/candidates.py b/tensorflow/contrib/constrained_optimization/python/candidates.py
index 66d7ebed74d..c1bcb30fae7 100644
--- a/tensorflow/contrib/constrained_optimization/python/candidates.py
+++ b/tensorflow/contrib/constrained_optimization/python/candidates.py
@@ -48,7 +48,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 
 def _find_best_candidate_distribution_helper(objective_vector,
@@ -294,7 +293,7 @@ def find_best_candidate_index(objective_vector,
     maximum_ranks = scipy.stats.rankdata(objective_vector, method="min")
   else:
     maximum_ranks = np.zeros(nn, dtype=np.int64)
-  for ii in xrange(mm):
+  for ii in range(mm):
     # Take the maximum of the constraint functions with zero, since we want to
     # rank the magnitude of constraint *violations*. If the constraint is
     # satisfied, then we don't care how much it's satisfied by (as a result, we
@@ -306,7 +305,7 @@ def find_best_candidate_index(objective_vector,
   best_index = None
   best_rank = float("Inf")
   best_objective = float("Inf")
-  for ii in xrange(nn):
+  for ii in range(nn):
     if maximum_ranks[ii] < best_rank:
       best_index = ii
       best_rank = maximum_ranks[ii]
diff --git a/tensorflow/contrib/cudnn_rnn/python/kernel_tests/cudnn_rnn_ops_benchmark.py b/tensorflow/contrib/cudnn_rnn/python/kernel_tests/cudnn_rnn_ops_benchmark.py
index 933df6d71dd..72a07bd0c83 100644
--- a/tensorflow/contrib/cudnn_rnn/python/kernel_tests/cudnn_rnn_ops_benchmark.py
+++ b/tensorflow/contrib/cudnn_rnn/python/kernel_tests/cudnn_rnn_ops_benchmark.py
@@ -20,7 +20,6 @@ from __future__ import print_function
 
 import time
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 from tensorflow.contrib import rnn as contrib_rnn
 from tensorflow.contrib.cudnn_rnn.python.ops import cudnn_rnn_ops
 from tensorflow.contrib.rnn.python.ops import lstm_ops
@@ -74,7 +73,7 @@ class CudnnRNNBenchmark(test.Benchmark):
     benchmark_steps = 20
     with session.Session() as sess:
       sess.run(variables.global_variables_initializer())
-      for i in xrange(burn_in_steps + benchmark_steps):
+      for i in range(burn_in_steps + benchmark_steps):
         if i == burn_in_steps:
           start_time = time.time()
         sess.run(op)
diff --git a/tensorflow/contrib/eager/python/examples/densenet/densenet_test.py b/tensorflow/contrib/eager/python/examples/densenet/densenet_test.py
index a9fb0035d29..16744faf549 100644
--- a/tensorflow/contrib/eager/python/examples/densenet/densenet_test.py
+++ b/tensorflow/contrib/eager/python/examples/densenet/densenet_test.py
@@ -235,13 +235,13 @@ class DensenetBenchmark(tf.test.Benchmark):
       num_iters = 30
       with tf.device(device):
         images, _ = random_batch(batch_size, data_format)
-        for _ in xrange(num_burn):
+        for _ in range(num_burn):
           model(images, training=False).cpu()
         if execution_mode:
           tfe.async_wait()
         gc.collect()
         start = time.time()
-        for _ in xrange(num_iters):
+        for _ in range(num_iters):
           model(images, training=False).cpu()
         if execution_mode:
           tfe.async_wait()
@@ -286,7 +286,7 @@ class DensenetBenchmark(tf.test.Benchmark):
         num_iters = 10
         with tf.device(device):
           iterator = make_iterator((images, labels))
-          for _ in xrange(num_burn):
+          for _ in range(num_burn):
             (images, labels) = iterator.next()
             apply_grads(model, optimizer,
                         compute_gradients(model, images, labels))
@@ -296,7 +296,7 @@ class DensenetBenchmark(tf.test.Benchmark):
           gc.collect()
 
           start = time.time()
-          for _ in xrange(num_iters):
+          for _ in range(num_iters):
             (images, labels) = iterator.next()
             apply_grads(model, optimizer,
                         compute_gradients(model, images, labels))
diff --git a/tensorflow/contrib/eager/python/examples/resnet50/resnet50_test.py b/tensorflow/contrib/eager/python/examples/resnet50/resnet50_test.py
index fb81979d7bd..941bfd68200 100644
--- a/tensorflow/contrib/eager/python/examples/resnet50/resnet50_test.py
+++ b/tensorflow/contrib/eager/python/examples/resnet50/resnet50_test.py
@@ -22,7 +22,6 @@ import gc
 import tempfile
 import time
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 import tensorflow as tf
 
 import tensorflow.contrib.eager as tfe
@@ -227,13 +226,13 @@ class ResNet50Benchmarks(tf.test.Benchmark):
       num_iters = 30
       with tf.device(device):
         images, _ = random_batch(batch_size, data_format)
-        for _ in xrange(num_burn):
+        for _ in range(num_burn):
           model(images, training=False).cpu()
         if execution_mode:
           tfe.async_wait()
         gc.collect()
         start = time.time()
-        for _ in xrange(num_iters):
+        for _ in range(num_iters):
           model(images, training=False).cpu()
         if execution_mode:
           tfe.async_wait()
@@ -273,7 +272,7 @@ class ResNet50Benchmarks(tf.test.Benchmark):
         num_iters = 10
         with tf.device(device):
           iterator = make_iterator((images, labels))
-          for _ in xrange(num_burn):
+          for _ in range(num_burn):
             (images, labels) = iterator.next()
             apply_grads(model, optimizer,
                         compute_gradients(model, images, labels))
@@ -283,7 +282,7 @@ class ResNet50Benchmarks(tf.test.Benchmark):
           gc.collect()
 
           start = time.time()
-          for _ in xrange(num_iters):
+          for _ in range(num_iters):
             (images, labels) = iterator.next()
             apply_grads(model, optimizer,
                         compute_gradients(model, images, labels))
diff --git a/tensorflow/contrib/eager/python/examples/revnet/cifar_tfrecords.py b/tensorflow/contrib/eager/python/examples/revnet/cifar_tfrecords.py
index 377844ad8fb..ec1c9323498 100644
--- a/tensorflow/contrib/eager/python/examples/revnet/cifar_tfrecords.py
+++ b/tensorflow/contrib/eager/python/examples/revnet/cifar_tfrecords.py
@@ -28,7 +28,7 @@ import sys
 import tarfile
 
 from absl import flags
-from six.moves import cPickle as pickle
+import pickle as pickle
 from six.moves import urllib
 import tensorflow as tf
 
diff --git a/tensorflow/contrib/eager/python/examples/spinn/spinn_test.py b/tensorflow/contrib/eager/python/examples/spinn/spinn_test.py
index 6e47cc57051..0ee1f945bf2 100644
--- a/tensorflow/contrib/eager/python/examples/spinn/spinn_test.py
+++ b/tensorflow/contrib/eager/python/examples/spinn/spinn_test.py
@@ -26,7 +26,6 @@ import tempfile
 import time
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 import tensorflow as tf
 
 # pylint: disable=g-bad-import-order
@@ -462,7 +461,7 @@ class EagerSpinnSNLIClassifierBenchmark(test.Benchmark):
 
       gc.collect()
       start_time = time.time()
-      for _ in xrange(benchmark_iterations):
+      for _ in range(benchmark_iterations):
         trainer.train_batch(labels, prem, prem_trans, hypo, hypo_trans)
       wall_time = time.time() - start_time
       # Named "examples"_per_sec to conform with other benchmarks.
diff --git a/tensorflow/contrib/factorization/examples/mnist.py b/tensorflow/contrib/factorization/examples/mnist.py
index 06a62db0049..ce25a85f384 100644
--- a/tensorflow/contrib/factorization/examples/mnist.py
+++ b/tensorflow/contrib/factorization/examples/mnist.py
@@ -33,7 +33,6 @@ import sys
 import tempfile
 import time
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 import tensorflow as tf
 
 from tensorflow.examples.tutorials.mnist import input_data
@@ -106,7 +105,7 @@ def do_eval(sess,
   batch_size = min(FLAGS.batch_size, data_set.num_examples)
   steps_per_epoch = data_set.num_examples // batch_size
   num_examples = steps_per_epoch * batch_size
-  for _ in xrange(steps_per_epoch):
+  for _ in range(steps_per_epoch):
     feed_dict = fill_feed_dict(data_set,
                                images_placeholder,
                                labels_placeholder,
@@ -227,7 +226,7 @@ def run_training():
 
     # Start the training loop.
     max_test_prec = 0
-    for step in xrange(FLAGS.max_steps):
+    for step in range(FLAGS.max_steps):
       start_time = time.time()
 
       # Fill a feed dictionary with the actual set of images and labels
diff --git a/tensorflow/contrib/factorization/python/ops/factorization_ops.py b/tensorflow/contrib/factorization/python/ops/factorization_ops.py
index e04de0579b1..d5407b70830 100644
--- a/tensorflow/contrib/factorization/python/ops/factorization_ops.py
+++ b/tensorflow/contrib/factorization/python/ops/factorization_ops.py
@@ -20,7 +20,6 @@ from __future__ import print_function
 
 import numbers
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.contrib.factorization.python.ops import gen_factorization_ops
 from tensorflow.contrib.util import loader
@@ -512,7 +511,7 @@ class WALSModel(object):
       assert var
       cache = [
           WALSModel._transient_var(name="%s_shard_%d" % (name, i))
-          for i in xrange(len(var))
+          for i in range(len(var))
       ]
       reset_ops = []
       for i, c in enumerate(cache):
@@ -667,7 +666,7 @@ class WALSModel(object):
       sharded_values = data_flow_ops.dynamic_partition(values, assignments,
                                                        num_shards)
       updates = []
-      for i in xrange(num_shards):
+      for i in range(num_shards):
         updates.append(
             state_ops.scatter_update(factor[i], sharded_ids[i], sharded_values[
                 i]))
diff --git a/tensorflow/contrib/factorization/python/ops/factorization_ops_test.py b/tensorflow/contrib/factorization/python/ops/factorization_ops_test.py
index 6aa62fb82e8..c2f4bd9be2b 100644
--- a/tensorflow/contrib/factorization/python/ops/factorization_ops_test.py
+++ b/tensorflow/contrib/factorization/python/ops/factorization_ops_test.py
@@ -19,7 +19,6 @@ from __future__ import division
 from __future__ import print_function
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.contrib.factorization.python.ops import factorization_ops
 from tensorflow.contrib.factorization.python.ops import factorization_ops_test_utils
@@ -659,7 +658,7 @@ class WalsModelTest(test.TestCase):
 
     model.initialize_op.run()
     model.worker_init.run()
-    for _ in xrange(num_iterations):
+    for _ in range(num_iterations):
       model.row_update_prep_gramian_op.run()
       model.initialize_row_update_op.run()
       row_update_op.run()
@@ -676,7 +675,7 @@ class WalsModelTest(test.TestCase):
     with ops.Graph().as_default(), self.cached_session():
       data = np.dot(np.random.rand(rows, 3), np.random.rand(
           3, cols)).astype(np.float32) / 3.0
-      indices = [[i, j] for i in xrange(rows) for j in xrange(cols)]
+      indices = [[i, j] for i in range(rows) for j in range(cols)]
       values = data.reshape(-1)
       inp = sparse_tensor.SparseTensor(indices, values, [rows, cols])
       model = factorization_ops.WALSModel(
@@ -706,7 +705,7 @@ class WalsModelTest(test.TestCase):
     with ops.Graph().as_default(), self.cached_session():
       data = np.dot(np.random.rand(rows, 3), np.random.rand(
           3, cols)).astype(np.float32) / 3.0
-      indices = [[i, j] for i in xrange(rows) for j in xrange(cols)]
+      indices = [[i, j] for i in range(rows) for j in range(cols)]
       values = data.reshape(-1)
       inp = sparse_tensor.SparseTensor(indices, values, [rows, cols])
       model = factorization_ops.WALSModel(
@@ -744,7 +743,7 @@ class WalsModelTest(test.TestCase):
       indices = np.array(
           list(
               filter(keep_index,
-                     [[i, j] for i in xrange(rows) for j in xrange(cols)])))
+                     [[i, j] for i in range(rows) for j in range(cols)])))
       values = data[indices[:, 0], indices[:, 1]]
       inp = sparse_tensor.SparseTensor(indices, values, [rows, cols])
       model = factorization_ops.WALSModel(
@@ -760,8 +759,8 @@ class WalsModelTest(test.TestCase):
       row_factor = model.row_factors[0].eval()
       col_factor = model.col_factors[0].eval()
       out = np.dot(row_factor, np.transpose(col_factor))
-      for i in xrange(rows):
-        for j in xrange(cols):
+      for i in range(rows):
+        for j in range(cols):
           if keep_index([i, j]):
             self.assertNear(
                 data[i][j], out[i][j], err=0.4, msg="%d, %d" % (i, j))
diff --git a/tensorflow/contrib/factorization/python/ops/gmm_ops_test.py b/tensorflow/contrib/factorization/python/ops/gmm_ops_test.py
index 112e4d289b0..d208c9c5751 100644
--- a/tensorflow/contrib/factorization/python/ops/gmm_ops_test.py
+++ b/tensorflow/contrib/factorization/python/ops/gmm_ops_test.py
@@ -21,7 +21,6 @@ from __future__ import print_function
 import time
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.contrib.factorization.python.ops import gmm_ops
 from tensorflow.python.framework import constant_op
@@ -59,7 +58,7 @@ class GmmOpsTest(test.TestCase):
     """
     vectors = []
     classes = []
-    for _ in xrange(num_vectors):
+    for _ in range(num_vectors):
       if np.random.random() > 0.5:
         vectors.append([np.random.normal(2.0, 0.6), np.random.normal(2.0, 0.9)])
         classes.append(0)
@@ -82,7 +81,7 @@ class GmmOpsTest(test.TestCase):
     """
     vectors = []
     classes = []
-    for _ in xrange(num_vectors):
+    for _ in range(num_vectors):
       current_class = np.random.random_integers(0, len(centers) - 1)
       vectors.append([
           np.random.normal(centers[current_class][0],
@@ -128,7 +127,7 @@ class GmmOpsTest(test.TestCase):
         variables.global_variables_initializer().run()
         sess.run(init_op)
         first_loss = sess.run(loss_op)
-        for _ in xrange(self.iterations):
+        for _ in range(self.iterations):
           sess.run(training_op)
         assignments = sess.run(assignments)
         end_loss = sess.run(loss_op)
@@ -152,7 +151,7 @@ class GmmOpsTest(test.TestCase):
       training_ops = gmm_tool.training_ops()
       variables.global_variables_initializer().run()
       sess.run(gmm_tool.init_ops())
-      for _ in xrange(self.iterations):
+      for _ in range(self.iterations):
         sess.run(training_ops)
 
       # Only the probability to each class is updated.
@@ -170,7 +169,7 @@ class GmmOpsTest(test.TestCase):
       training_ops = gmm_tool.training_ops()
       variables.global_variables_initializer().run()
       sess.run(gmm_tool.init_ops())
-      for _ in xrange(self.iterations):
+      for _ in range(self.iterations):
         sess.run(training_ops)
       alphas = sess.run(gmm_tool.alphas())
       self.assertAlmostEqual(alphas[0], alphas[1])
@@ -189,7 +188,7 @@ class GmmOpsTest(test.TestCase):
       training_ops = gmm_tool.training_ops()
       variables.global_variables_initializer().run()
       sess.run(gmm_tool.init_ops())
-      for _ in xrange(self.iterations):
+      for _ in range(self.iterations):
         sess.run(training_ops)
       alphas = sess.run(gmm_tool.alphas())
       self.assertAlmostEqual(alphas[0], alphas[1])
diff --git a/tensorflow/contrib/factorization/python/ops/kmeans.py b/tensorflow/contrib/factorization/python/ops/kmeans.py
index 260ea5bf127..f4ec267a386 100644
--- a/tensorflow/contrib/factorization/python/ops/kmeans.py
+++ b/tensorflow/contrib/factorization/python/ops/kmeans.py
@@ -265,7 +265,7 @@ class KMeansClustering(estimator.Estimator):
   # train
   num_iterations = 10
   previous_centers = None
-  for _ in xrange(num_iterations):
+  for _ in range(num_iterations):
     kmeans.train(input_fn)
     cluster_centers = kmeans.cluster_centers()
     if previous_centers is not None:
diff --git a/tensorflow/contrib/image/python/kernel_tests/distort_image_ops_test.py b/tensorflow/contrib/image/python/kernel_tests/distort_image_ops_test.py
index ac8573445ca..03be762c9c2 100644
--- a/tensorflow/contrib/image/python/kernel_tests/distort_image_ops_test.py
+++ b/tensorflow/contrib/image/python/kernel_tests/distort_image_ops_test.py
@@ -21,7 +21,6 @@ from __future__ import print_function
 import time
 
 import numpy as np
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.contrib.image.python.ops import distort_image_ops
 from tensorflow.core.protobuf import config_pb2
@@ -271,7 +270,7 @@ class AdjustHueInYiqBenchmark(test.Benchmark):
         outputs = distort_image_ops.adjust_hsv_in_yiq(inputs, delta, 1, 1)
         run_op = control_flow_ops.group(outputs)
         sess.run(variables.global_variables_initializer())
-        for i in xrange(warmup_rounds + benchmark_rounds):
+        for i in range(warmup_rounds + benchmark_rounds):
           if i == warmup_rounds:
             start = time.time()
           sess.run(run_op)
@@ -315,10 +314,10 @@ class AdjustSaturationInYiqBenchmark(test.Benchmark):
         outputs = distort_image_ops.adjust_hsv_in_yiq(inputs, 0, scale, 1)
         run_op = control_flow_ops.group(outputs)
         sess.run(variables.global_variables_initializer())
-        for _ in xrange(warmup_rounds):
+        for _ in range(warmup_rounds):
           sess.run(run_op)
         start = time.time()
-        for _ in xrange(benchmark_rounds):
+        for _ in range(benchmark_rounds):
           sess.run(run_op)
     end = time.time()
     step_time = (end - start) / benchmark_rounds
diff --git a/tensorflow/contrib/kernel_methods/python/mappers/random_fourier_features_test.py b/tensorflow/contrib/kernel_methods/python/mappers/random_fourier_features_test.py
index bad0a596a78..12ff66982e7 100644
--- a/tensorflow/contrib/kernel_methods/python/mappers/random_fourier_features_test.py
+++ b/tensorflow/contrib/kernel_methods/python/mappers/random_fourier_features_test.py
@@ -18,7 +18,6 @@ from __future__ import absolute_import
 from __future__ import division
 from __future__ import print_function
 
-from six.moves import xrange  # pylint: disable=redefined-builtin
 
 from tensorflow.contrib.kernel_methods.python.mappers import dense_kernel_mapper
 from tensorflow.contrib.kernel_methods.python.mappers.random_fourier_features import RandomFourierFeatureMapper
@@ -134,7 +133,7 @@ class RandomFourierFeatureMapperTest(TensorFlowTestCase):
     points_shape = [1, input_dim]
     points = [
         random_ops.random_uniform(shape=points_shape, maxval=1.0)
-        for _ in xrange(num_points)
+        for _ in range(num_points)
     ]
 
     normalized_points = [nn.l2_normalize(point, dim=1) for point in points]
diff --git a/tensorflow/contrib/labeled_tensor/python/ops/core.py b/tensorflow/contrib/labeled_tensor/python/ops/core.py
index 394254cbd90..ef48a6de017 100644
--- a/tensorflow/contrib/labeled_tensor/python/ops/core.py
+++ b/tensorflow/contrib/labeled_tensor/python/ops/core.py
@@ -33,7 +33,6 @@ import numpy as np
 from six import binary_type
 from six import string_types
 from six import text_type
-from six.moves import range  # pylint: disable=redefined-builtin
 
 from tensorflow.contrib.labeled_tensor.python.ops import _typecheck as tc
 from tensorflow.python.framework import dtypes
